<?php

namespace App\Models;

use Illuminate\Database\Eloquent\Builder;
use Illuminate\Database\Eloquent\Model;
use Illuminate\Database\Eloquent\Prunable;
use Illuminate\Database\Eloquent\Relations\BelongsTo;
use Illuminate\Database\Eloquent\SoftDeletes;

class ProductionLineStop extends Model
{
    use Prunable;
    use SoftDeletes;

    protected $fillable = [
        'plant_id',
        'line_id',
        'shift_id',
        'linestop_id',
        'from_datetime',
        'to_datetime',
        'stop_hour',
        'stop_min',
        'operator_id',
        'created_at',
        'updated_at',
    ];

    public function plant(): BelongsTo
    {
        return $this->belongsTo(Plant::class);
    }

    public function shift(): BelongsTo
    {
        return $this->belongsTo(Shift::class);
    }

    public function line(): BelongsTo
    {
        return $this->belongsTo(Line::class);
    }

    public function linestop(): BelongsTo
    {
        return $this->belongsTo(LineStop::class);
    }

    // //..this is my code below
    // public function lineStopRelation()
    // {
    //     return $this->belongsTo(LineStop::class, 'linestop_id');
    // }

    public function prunable(): Builder
    {
        return static::where('created_at', '<=', now()->subMonthsNoOverflow(6));
    }
}
